#include <windows.h>
#include <winuser.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <time.h>
#include <commctrl.h>
#include <richedit.h>
#include "myrtf.h"
#include "jpg.h"
#include "resource.h"

BOOL CALLBACK MainProc(HWND hwnd,UINT msg,UINT wparam,LONG lparam);
BOOL CALLBACK StartScreenProc(HWND hwnd,UINT msg,UINT wparam,LONG lparam);
BOOL CALLBACK MenuProc(HWND hwnd,UINT msg,UINT wparam,LONG lparam);
BOOL CALLBACK MenuProc1(HWND hwnd,UINT msg,UINT wparam,LONG lparam);
BOOL CALLBACK SlantsProc(HWND hwnd,UINT msg,UINT wparam,LONG lparam);
BOOL CALLBACK LetterProc(HWND hwnd,UINT msg,UINT wparam,LONG lparam);
BOOL CALLBACK AdviceProc(HWND hwnd,UINT msg,UINT wparam,LONG lparam);
BOOL SaveAnalysis(HWND hwnd);
BOOL PrintAnalysis(HWND hwnd);

HINSTANCE myinstance;
HWND hwnd_status;
DWORD analysen;
char buf[256];

typedef struct
{
	BYTE fit[11];
} ITEM;

typedef struct
{
	BYTE fit[10];
} LETTERITEM;

ITEM item[10];
LETTERITEM letteritem[22];

typedef struct
{
	WORD pagenum;
	WORD pages;
	HBITMAP bmap;
	HWND hwnd;
	WORD chapter;
	WORD activebutton;
	WORD startpage;
	char *id;
} DATA;

char *idtable[] =
{
	"SLANT","SIZE","SPACING","ZONES","PRESSURE","GENERAL","LETTERS","SIGNATURES",
	"MARGINS","CONNECTS"
};

BYTE anzahlletteritems[] = {6,4,4,3,3,3,4,4,4,5,3,4,3,4,4,3,5,4,5,4,4,4};
char *itemnames[22][6] =
{
	{"Inflated","Deflated","Left-tilting","Right-tilting","Vertical","Printed 'I'"},
	{"Dot High above Stem","Dot at Right of Stem","Dot at Left of Stem","Wavy Dor","",""},
	{"Circled Dot","Absence of Dot","Flying 'v' Dor","Tented Dot","",""},
	{"Average Balanced Bar Crossing","Cross to Left","Cross to Right","","",""},
	{"Down-slanted","Up-slanted","Bar above Stem","","",""},
	{"Low Bar on the Stem","Short Bar","Long Bar","","",""},
	{"Absent Bar","Wavy Bar","Starlike t","Tented","",""},
	{"Crossing Back","Down-turned Hook","Upturned Hook","Looped Stem","",""},
	{"Double-looped","Open at Top","Open at Bottom","Closed and clean","",""},
	{"Bottom Portion Open","Bottom Portion Closed","Tall and Narrow","Short and Full","Without Upper Loop",""},
	{"Crowns or Loops","Beginning Stroke","Plain","","",""},
	{"Loopy Stem","Tall, Unlooped Stem","Short, Unlooped Stem","Tall and Wide Stem","",""},
	{"Bottom Open","Body Closed","Left Flag","","",""},
	{"Closed Loop","Broad Loop","Greek 'e'","Narrow Loop","",""},
	{"Balanced Upper and Lower Parts","Absent Upper Loop","Large Lower Loop","Large Upper Loop","",""},
	{"Angular","Fluid Form","Cross Form","","",""},
	{"Long Stem","Rounded Full Loop","Absent Loop","Triangular Stem","Resembling Number '8'",""},
	{"Short Loop","Tall, Narrow Loop","Tall, Wide Loop","Absent Loop","",""},
	{"Rounded","Peaked","Initial Strike Large and Flourishing","Final Stroke Higher than Others","Graceful First Stroke",""},
	{"Large Loop","Short Upper Stem","High Upper Stem","Open Body","",""},
	{"Flat Topped","Double Peaked","Initial Stroke Looped","Parochial 'r'","",""},
	{"Printed 's'","Upper Peak","Rounded Top","Enrolled","",""}
};


int pascal WinMain(HINSTANCE hinstance,HINSTANCE hprevinstance,LPSTR cmdline,int cmdshow)
{
	myinstance = hinstance;
	InitCommonControls();
	LoadLibrary("riched32.dll");
	NVInitLib();
	DialogBox(hinstance,"maindialog",NULL,MainProc);
	NVFreeLib();
	return(0);
}


void Status_Text(char *txt)
{
	char buf[128];
	sprintf(buf," %s",txt);
	SendMessage(hwnd_status,SB_SETTEXT,0,(LPARAM)buf);
}


void Status_Datum()
{
	char buf[50];
	time_t zeit;
	struct tm *tm;
	zeit = time(NULL);
	tm = localtime(&zeit);
	strftime(buf,sizeof(buf)," %m/%d/%Y",tm);
	SendMessage(hwnd_status,SB_SETTEXT,2,(LPARAM)buf);
	strftime(buf,sizeof(buf)," %I:%M %S %p",tm);
	SendMessage(hwnd_status,SB_SETTEXT,3,(LPARAM)buf);
}


void Status_Analysis()
{
	char buf[50];
	sprintf(buf," Analysis: %d",analysen);
	SendMessage(hwnd_status,SB_SETTEXT,1,(LPARAM)buf);
}

void SaveCounter()
{
	int fn;

	fn = open(".\\counter.dat",O_BINARY|O_CREAT|O_TRUNC|O_WRONLY,S_IREAD|S_IWRITE);
	write(fn,&analysen,sizeof(analysen));
	close(fn);
}

void LoadCounter()
{
	int fn;

	analysen = 0;
	fn = open(".\\counter.dat",O_BINARY|O_RDONLY);
	if(fn == -1) return;
	read(fn,&analysen,sizeof(analysen));
	close(fn);
}


WORD activebutton,startpage;

BOOL CALLBACK MainProc(HWND hwnd,UINT msg,UINT wparam,LONG lparam)
{
	static HWND screen,hwnd_screen,hwnd_menu1,hwnd_screen1;
	static int mainsbarwidth[4];
	static RECT rc;
	switch(msg)
	{
		case	WM_INITDIALOG:
					GetWindowRect(hwnd,&rc);
					hwnd_status = CreateWindowEx(0L,STATUSCLASSNAME,"",WS_CHILD|WS_VISIBLE,0,0,0,0,hwnd,(HMENU)0,myinstance,NULL);
					mainsbarwidth[3] = -1;
					mainsbarwidth[2] = rc.right-rc.left-80;
					mainsbarwidth[1] = mainsbarwidth[2]-72;
					mainsbarwidth[0] = mainsbarwidth[1]-85;
					SendMessage(hwnd_status,SB_SETPARTS,4,(LPARAM)mainsbarwidth);
					LoadCounter();
					Status_Datum();
					Status_Analysis();
					SetTimer(hwnd,1,1000,NULL);
					screen = CreateDialog(myinstance,"StartDlg",hwnd,StartScreenProc);
					ShowWindow(screen,SW_SHOW);
					return(TRUE);
//					break;
		case	WM_DESTROY:
					EndDialog(hwnd,TRUE);
					return(TRUE);
		case	WM_TIMER:
					Status_Datum();
					break;
		case	WM_CLOSE:
					KillTimer(hwnd,1);
					DestroyWindow(screen);
					SendMessage(hwnd,WM_DESTROY,0,0L);
					return(TRUE);
		case	WM_APP:	// WPARAM = screenmode
					switch(LOWORD(wparam))
					{
						case	0:	// Show Start Dialog
									ZeroMemory(&item,sizeof(item));
									ZeroMemory(&letteritem,sizeof(letteritem));
									DestroyWindow(screen);
									screen = CreateDialog(myinstance,"StartDlg",hwnd,StartScreenProc);
									ShowWindow(screen,SW_SHOW);
									break;
						case	1:	// Show Menu Dialog
									DestroyWindow(screen);
									screen = CreateDialog(myinstance,"MenuDlg",hwnd,MenuProc);
									ShowWindow(screen,SW_SHOW);
									break;
						case	2:	// Show Category
									activebutton = HIWORD(wparam);
									hwnd_screen = CreateDialogParam(myinstance,"ScreenDlg",hwnd,SlantsProc,lparam);
									ShowWindow(screen,SW_HIDE);
									ShowWindow(hwnd_screen,SW_SHOW);
									break;
						case	3:	// Back to Menu Dialog
									ShowWindow(screen,SW_SHOW);
									ShowWindow(hwnd_screen,SW_HIDE);
									DestroyWindow(hwnd_screen);
									break;
						case	4:	// Show Letter Menu Dialog called from Menu Dialog
									hwnd_menu1 = CreateDialogParam(myinstance,"MENUDLG1",hwnd,MenuProc1,lparam);
									ShowWindow(screen,SW_HIDE);
									ShowWindow(hwnd_menu1,SW_SHOW);
									break;
						case	5:	// Back to Category
									ShowWindow(screen,SW_SHOW);
									ShowWindow(hwnd_menu1,SW_HIDE);
									DestroyWindow(hwnd_menu1);
									break;
						case	6:	// Show Individual Letter called from Letter Menu Dialog
									startpage = HIWORD(wparam);
									hwnd_screen1 = CreateDialogParam(myinstance,"ScreenDlg1",hwnd,LetterProc,lparam);
									ShowWindow(hwnd_menu1,SW_HIDE);
									ShowWindow(hwnd_screen1,SW_SHOW);
									break;
						case	7:	// Back to Letter Menu Dialog
									ShowWindow(hwnd_menu1,SW_SHOW);
									ShowWindow(hwnd_screen1,SW_HIDE);
									DestroyWindow(hwnd_screen1);
									break;
						case	8:
									hwnd_screen = CreateDialog(myinstance,"AdviceDlg",hwnd,AdviceProc);
									ShowWindow(screen,SW_HIDE);
									ShowWindow(hwnd_screen,SW_SHOW);
									break;
						case	9:
									ShowWindow(screen,SW_SHOW);
									ShowWindow(hwnd_screen,SW_HIDE);
									DestroyWindow(hwnd_screen);
									break;
					}
					break;
	}
	return(FALSE);
}



BOOL CALLBACK StartScreenProc(HWND hwnd,UINT msg,UINT wparam,LONG lparam)
{
	switch(msg)
	{
		case	WM_INITDIALOG:
					break;
		case	WM_DESTROY:
					EndDialog(hwnd,TRUE);
					return(TRUE);
		case	WM_CLOSE:
					SendMessage(hwnd,WM_DESTROY,0,0L);
					return(TRUE);
		case	WM_COMMAND:
					switch(LOWORD(wparam))
					{
						case	IDCANCEL:
									SendMessage(GetParent(hwnd),WM_CLOSE,MAKEWPARAM(0,0),0L);
									break;
						case	IDOK:
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(1,0),0L);
									break;
						case	IDC_SETTINGS:
									break;
						default:
									break;
					}
					break;
	}
	return(FALSE);
}


int CheckCategories()
{
	int i,j;
	for(i=0; i<10; i++) for(j=0; j<11; j++) if(item[i].fit[j]) return(1);
	for(i=0; i<17; i++) for(j=0; j<6; j++) if(letteritem[i].fit[j]) return(1);
	return(0);
}

BOOL CALLBACK MenuProc(HWND hwnd,UINT msg,UINT wparam,LONG lparam)
{
	static HWND hwndletter;
	switch(msg)
	{
		case	WM_INITDIALOG:
					LoadRtfFromRes(GetDlgItem(hwnd,IDC_RICHEDIT),"INTRODUCTION");
					break;
		case	WM_DESTROY:
					EndDialog(hwnd,TRUE);
					return(TRUE);
		case	WM_CLOSE:
					SendMessage(hwnd,WM_DESTROY,0,0L);
					return(TRUE);
		case	WM_APP:
					DestroyWindow(hwndletter);
					ShowWindow(hwnd,SW_SHOW);
					break;
		case	WM_COMMAND:
					switch(LOWORD(wparam))
					{
						case	IDC_BACK:
									if(CheckCategories())
									{
										if(MessageBox(hwnd,"If you go back to the main screen, you lost all selected categories.\r\nAre you sure you want to go back?","User Message",MB_YESNO|MB_ICONINFORMATION) == IDYES)
										SendMessage(GetParent(hwnd),WM_APP,0,0L);
										break;
									}
									else SendMessage(GetParent(hwnd),WM_APP,0,0L);
									break;
						case	IDC_RESET:
									LoadRtfFromRes(GetDlgItem(hwnd,IDC_RICHEDIT),"INTRODUCTION");
									ZeroMemory(&item,sizeof(item));
									ZeroMemory(&letteritem,sizeof(letteritem));
									break;
						case	IDC_RESET1:
									ZeroMemory(&item[0].fit,sizeof(item[0].fit));
									break;
						case	IDC_RESET2:
									ZeroMemory(&item[1].fit,sizeof(item[1].fit));
									break;
						case	IDC_RESET3:
									ZeroMemory(&item[2].fit,sizeof(item[2].fit));
									break;
						case	IDC_RESET4:
									ZeroMemory(&item[3].fit,sizeof(item[3].fit));
									break;
						case	IDC_RESET5:
									ZeroMemory(&item[4].fit,sizeof(item[4].fit));
									break;
						case	IDC_RESET6:
									ZeroMemory(&item[5].fit,sizeof(item[5].fit));
									break;
						case	IDC_RESET7:
									ZeroMemory(&item[6].fit,sizeof(item[6].fit));
									ZeroMemory(&letteritem,sizeof(letteritem));
									break;
						case	IDC_RESET8:
									ZeroMemory(&item[7].fit,sizeof(item[7].fit));
									break;
						case	IDC_RESET9:
									ZeroMemory(&item[8].fit,sizeof(item[8].fit));
									break;
						case	IDC_RESET10:
									ZeroMemory(&item[9].fit,sizeof(item[9].fit));
									break;
						case	IDC_INFO1:
									LoadRtfFromRes(GetDlgItem(hwnd,IDC_RICHEDIT),"SLANT_INTRO");
									break;					
						case	IDC_INFO2:
									LoadRtfFromRes(GetDlgItem(hwnd,IDC_RICHEDIT),"SIZE_INTRO");
									break;
						case	IDC_INFO3:
									LoadRtfFromRes(GetDlgItem(hwnd,IDC_RICHEDIT),"SPACING_INTRO");
									break;
						case	IDC_INFO4:
									LoadRtfFromRes(GetDlgItem(hwnd,IDC_RICHEDIT),"ZONES_INTRO");
									break;
						case	IDC_INFO5:
									LoadRtfFromRes(GetDlgItem(hwnd,IDC_RICHEDIT),"PRESSURE_INTRO");
									break;
						case	IDC_INFO6:
									LoadRtfFromRes(GetDlgItem(hwnd,IDC_RICHEDIT),"GENERAL_INTRO");
									break;
						case	IDC_INFO7:
									LoadRtfFromRes(GetDlgItem(hwnd,IDC_RICHEDIT),"LETTERS_INTRO");
									break;
						case	IDC_INFO8:
									LoadRtfFromRes(GetDlgItem(hwnd,IDC_RICHEDIT),"SIGNATURES_INTRO");
									break;
						case	IDC_INFO9:
									LoadRtfFromRes(GetDlgItem(hwnd,IDC_RICHEDIT),"MARGINS_INTRO");
									break;
						case	IDC_INFO10:
									LoadRtfFromRes(GetDlgItem(hwnd,IDC_RICHEDIT),"CONNECTS_INTRO");
									break;
						case	IDC_ANALYSE1:	// Slant
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(2,0),MAKELPARAM(0,6));
									break;
						case	IDC_ANALYSE2:	// Size
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(2,0),MAKELPARAM(1,7));
									break;
						case	IDC_ANALYSE3:	// Spacing
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(2,0),MAKELPARAM(2,10));
									break;
						case	IDC_ANALYSE4:	// Zones
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(2,4),MAKELPARAM(3,14));
									break;
						case	IDC_ANALYSE5:	// Pressure
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(2,0),MAKELPARAM(4,3));
									break;
						case	IDC_ANALYSE6:	// General
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(2,0),MAKELPARAM(5,4));
									break;
						case	IDC_ANALYSE7:	// Letters
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(4,0),MAKELPARAM(6,0));
									break;
						case	IDC_ANALYSE8:	// Signatures
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(2,0),MAKELPARAM(7,9));
									break;
						case	IDC_ANALYSE9:	// Margins
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(2,0),MAKELPARAM(8,11));
									break;
						case	IDC_ANALYSE10:	// Connected
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(2,0),MAKELPARAM(9,2));
									break;
						case	IDC_GENERATE:
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(8,0),0L);
									break;
						default:
									break;
					}
					break;
	}
	return(FALSE);
}


void LoadData(DATA *data)
{
	char tmp[80];
	if(data->pagenum == 0) EnableWindow(GetDlgItem(data->hwnd,IDC_PREVIOUS),FALSE);
	else EnableWindow(GetDlgItem(data->hwnd,IDC_PREVIOUS),TRUE);
	if(data->pages > data->pagenum+1) EnableWindow(GetDlgItem(data->hwnd,IDC_NEXT),TRUE);
	else EnableWindow(GetDlgItem(data->hwnd,IDC_NEXT),FALSE);

	if(item[data->chapter].fit[data->pagenum] == 1)	SendMessage(GetDlgItem(data->hwnd,IDC_FIT),BM_SETCHECK,BST_CHECKED,0L);
	else SendMessage(GetDlgItem(data->hwnd,IDC_FIT),BM_SETCHECK,BST_UNCHECKED,0L);

	sprintf(tmp,".\\gfx\\%s_%02d.gif",data->id,data->pagenum+1);
	if(data->bmap) DeleteObject(data->bmap);
	data->bmap = (HBITMAP)NVLoadPicture(tmp);
	SendMessage(GetDlgItem(data->hwnd,IDC_IMAGE),STM_SETIMAGE,IMAGE_BITMAP,(LPARAM)data->bmap);

	sprintf(tmp,"%s_%02d",data->id,data->pagenum+1);
	LoadRtfFromRes(GetDlgItem(data->hwnd,IDC_RICHEDIT),tmp);

	sprintf(tmp,"You are on page %d of %d",data->pagenum+1,data->pages);
	SetWindowText(GetDlgItem(data->hwnd,IDC_PAGE),tmp);
}


BOOL CALLBACK SlantsProc(HWND hwnd,UINT msg,UINT wparam,LONG lparam)
{
	static DATA slant;
	switch(msg)
	{
		case	WM_INITDIALOG:
					slant.hwnd = hwnd;
					slant.pagenum = 0;
					slant.pages = HIWORD(lparam);
					slant.id = idtable[LOWORD(lparam)];
					slant.chapter = LOWORD(lparam);
					slant.bmap = NULL;
					slant.activebutton = activebutton;
					LoadData((DATA *)&slant);
					if(slant.pagenum >= slant.activebutton) EnableWindow(GetDlgItem(hwnd,IDC_FIT),TRUE);
					else EnableWindow(GetDlgItem(hwnd,IDC_FIT),FALSE);
					break;
		case	WM_DESTROY:
					DeleteObject(slant.bmap);
					EndDialog(hwnd,TRUE);
					return(TRUE);
		case	WM_CLOSE:
					SendMessage(hwnd,WM_DESTROY,0,0L);
					return(TRUE);
		case	WM_COMMAND:
					switch(LOWORD(wparam))
					{
						case	IDC_BACK:
									SendMessage(GetParent(hwnd),WM_APP,3,0L);
									break;
						case	IDC_NEXT:
									slant.pagenum++;
									LoadData((DATA *)&slant);
									if(slant.pagenum >= slant.activebutton) EnableWindow(GetDlgItem(hwnd,IDC_FIT),TRUE);
									else EnableWindow(GetDlgItem(hwnd,IDC_FIT),FALSE);
									break;
						case	IDC_PREVIOUS:
									slant.pagenum--;
									LoadData((DATA *)&slant);
									if(slant.pagenum >= slant.activebutton) EnableWindow(GetDlgItem(hwnd,IDC_FIT),TRUE);
									else EnableWindow(GetDlgItem(hwnd,IDC_FIT),FALSE);
									break;
						case	IDC_FIT:
									if(SendMessage(GetDlgItem(hwnd,IDC_FIT),BM_GETCHECK,0,0L) == BST_CHECKED)
									item[slant.chapter].fit[slant.pagenum] = 1;
									else item[slant.chapter].fit[slant.pagenum] = 0;
									break;
						default:
									break;
					}
					break;
	}
	return(FALSE);
}



BOOL CALLBACK MenuProc1(HWND hwnd,UINT msg,UINT wparam,LONG lparam)
{
	switch(msg)
	{
		case	WM_INITDIALOG:
					break;
		case	WM_DESTROY:
					EndDialog(hwnd,TRUE);
					return(TRUE);
		case	WM_CLOSE:
					SendMessage(hwnd,WM_DESTROY,0,0L);
					return(TRUE);
		case	WM_COMMAND:
					switch(LOWORD(wparam))
					{
						case	IDC_BACK:
									SendMessage(GetParent(hwnd),WM_APP,5,0L);
									break;
						case	IDC_RESET:
									ZeroMemory(&letteritem,sizeof(letteritem));
									break;
						case	IDC_RES1:
									ZeroMemory(&letteritem[0].fit,sizeof(letteritem[0].fit));
									break;
						case	IDC_RES2:
									ZeroMemory(&letteritem[1].fit,sizeof(letteritem[1].fit));
									break;
						case	IDC_RES3:
									ZeroMemory(&letteritem[2].fit,sizeof(letteritem[2].fit));
									break;
						case	IDC_RES4:
									ZeroMemory(&letteritem[3].fit,sizeof(letteritem[3].fit));
									break;
						case	IDC_RES5:
									ZeroMemory(&letteritem[4].fit,sizeof(letteritem[4].fit));
									break;
						case	IDC_RES6:
									ZeroMemory(&letteritem[5].fit,sizeof(letteritem[5].fit));
									break;
						case	IDC_RES7:
									ZeroMemory(&letteritem[6].fit,sizeof(letteritem[6].fit));
									break;
						case	IDC_RES8:
									ZeroMemory(&letteritem[7].fit,sizeof(letteritem[7].fit));
									break;
						case	IDC_RES9:
									ZeroMemory(&letteritem[8].fit,sizeof(letteritem[8].fit));
									break;
						case	IDC_RES10:
									ZeroMemory(&letteritem[9].fit,sizeof(letteritem[9].fit));
									break;
						case	IDC_RES11:
									ZeroMemory(&letteritem[10].fit,sizeof(letteritem[10].fit));
									break;
						case	IDC_RES12:
									ZeroMemory(&letteritem[11].fit,sizeof(letteritem[11].fit));
									break;
						case	IDC_RES13:
									ZeroMemory(&letteritem[12].fit,sizeof(letteritem[12].fit));
									break;
						case	IDC_RES14:
									ZeroMemory(&letteritem[13].fit,sizeof(letteritem[13].fit));
									break;
						case	IDC_RES15:
									ZeroMemory(&letteritem[14].fit,sizeof(letteritem[14].fit));
									break;
						case	IDC_RES16:
									ZeroMemory(&letteritem[15].fit,sizeof(letteritem[15].fit));
									break;
						case	IDC_RES17:
									ZeroMemory(&letteritem[16].fit,sizeof(letteritem[16].fit));
									break;
						case	IDC_ANALYSE1:	// I
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(6,0),MAKELPARAM(6,1));
									break;
						case	IDC_ANALYSE2:	// i
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(6,1),MAKELPARAM(6,2));
									break;
						case	IDC_ANALYSE3:	// t
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(6,3),MAKELPARAM(6,5));
									break;
						case	IDC_ANALYSE4:	// a, o
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(6,8),MAKELPARAM(6,1));
									break;
						case	IDC_ANALYSE5:	// b
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(6,9),MAKELPARAM(6,1));
									break;
						case	IDC_ANALYSE6:	// c
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(6,10),MAKELPARAM(6,1));
									break;
						case	IDC_ANALYSE7:	// d
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(6,11),MAKELPARAM(6,2));
									break;
						case	IDC_ANALYSE8:	// e
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(6,13),MAKELPARAM(6,1));
									break;
						case	IDC_ANALYSE9:	// f
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(6,14),MAKELPARAM(6,2));
									break;
						case	IDC_ANALYSE10:	// g, q, y, z
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(6,16),MAKELPARAM(6,1));
									break;
						case	IDC_ANALYSE11:	// h, k, l
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(6,17),MAKELPARAM(6,1));
									break;
						case	IDC_ANALYSE12:	// m, n
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(6,18),MAKELPARAM(6,1));
									break;
						case	IDC_ANALYSE13:	// p
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(6,19),MAKELPARAM(6,1));
									break;
						case	IDC_ANALYSE14:	// r
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(6,20),MAKELPARAM(6,1));
									break;
						case	IDC_ANALYSE15:	// s
									SendMessage(GetParent(hwnd),WM_APP,MAKEWPARAM(6,21),MAKELPARAM(6,1));
									break;
						case	IDC_ANALYSE16:	// loop
									break;
						case	IDC_ANALYSE17:	// knots, hawks, claws
									break;
						default:
									break;
					}
					break;
	}
	return(FALSE);
}


void LoadLetterData(DATA *data)
{
	char tmp[80];

	if(data->pagenum == 0) EnableWindow(GetDlgItem(data->hwnd,IDC_PREVPAGE),FALSE);
	else EnableWindow(GetDlgItem(data->hwnd,IDC_PREVPAGE),TRUE);
	if(data->pages > data->pagenum+1) EnableWindow(GetDlgItem(data->hwnd,IDC_NEXTPAGE),TRUE);
	else EnableWindow(GetDlgItem(data->hwnd,IDC_NEXTPAGE),FALSE);

	sprintf(tmp,".\\gfx\\%s_%02d.gif",data->id,data->startpage+1+data->pagenum);
	if(data->bmap) DeleteObject(data->bmap);
	data->bmap = (HBITMAP)NVLoadPicture(tmp);
	SendMessage(GetDlgItem(data->hwnd,IDC_IMAGE),STM_SETIMAGE,IMAGE_BITMAP,(LPARAM)data->bmap);
	sprintf(tmp,"%s_%02d",data->id,data->startpage+1+data->pagenum);
	LoadRtfFromRes(GetDlgItem(data->hwnd,IDC_RICHEDIT),tmp);

	ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK1),SW_HIDE);
	ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK2),SW_HIDE);
	ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK3),SW_HIDE);
	ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK4),SW_HIDE);
	ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK5),SW_HIDE);
	ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK6),SW_HIDE);
	if(anzahlletteritems[data->startpage+data->pagenum] == 1)
	{
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK1),SW_SHOW);
	}
	else if(anzahlletteritems[data->startpage+data->pagenum] == 2)
	{
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK1),SW_SHOW);
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK2),SW_SHOW);
	}
	else if(anzahlletteritems[data->startpage+data->pagenum] == 3)
	{
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK1),SW_SHOW);
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK2),SW_SHOW);
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK3),SW_SHOW);
	}
	else if(anzahlletteritems[data->startpage+data->pagenum] == 4)
	{
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK1),SW_SHOW);
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK2),SW_SHOW);
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK3),SW_SHOW);
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK4),SW_SHOW);
	}
	else if(anzahlletteritems[data->startpage+data->pagenum] == 5)
	{
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK1),SW_SHOW);
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK2),SW_SHOW);
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK3),SW_SHOW);
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK4),SW_SHOW);
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK5),SW_SHOW);
	}
	else if(anzahlletteritems[data->startpage+data->pagenum] == 6)
	{
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK1),SW_SHOW);
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK2),SW_SHOW);
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK3),SW_SHOW);
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK4),SW_SHOW);
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK5),SW_SHOW);
		ShowWindow(GetDlgItem(data->hwnd,IDC_CHECK6),SW_SHOW);
	}

	if(letteritem[data->startpage+data->pagenum].fit[0] == 1) SendMessage(GetDlgItem(data->hwnd,IDC_CHECK1),BM_SETCHECK,BST_CHECKED,0L);
	else SendMessage(GetDlgItem(data->hwnd,IDC_CHECK1),BM_SETCHECK,BST_UNCHECKED,0L);
	if(letteritem[data->startpage+data->pagenum].fit[1] == 1) SendMessage(GetDlgItem(data->hwnd,IDC_CHECK2),BM_SETCHECK,BST_CHECKED,0L);
	else SendMessage(GetDlgItem(data->hwnd,IDC_CHECK2),BM_SETCHECK,BST_UNCHECKED,0L);
	if(letteritem[data->startpage+data->pagenum].fit[2] == 1) SendMessage(GetDlgItem(data->hwnd,IDC_CHECK3),BM_SETCHECK,BST_CHECKED,0L);
	else SendMessage(GetDlgItem(data->hwnd,IDC_CHECK3),BM_SETCHECK,BST_UNCHECKED,0L);
	if(letteritem[data->startpage+data->pagenum].fit[3] == 1) SendMessage(GetDlgItem(data->hwnd,IDC_CHECK4),BM_SETCHECK,BST_CHECKED,0L);
	else SendMessage(GetDlgItem(data->hwnd,IDC_CHECK4),BM_SETCHECK,BST_UNCHECKED,0L);
	if(letteritem[data->startpage+data->pagenum].fit[4] == 1) SendMessage(GetDlgItem(data->hwnd,IDC_CHECK5),BM_SETCHECK,BST_CHECKED,0L);
	else SendMessage(GetDlgItem(data->hwnd,IDC_CHECK5),BM_SETCHECK,BST_UNCHECKED,0L);
	if(letteritem[data->startpage+data->pagenum].fit[5] == 1) SendMessage(GetDlgItem(data->hwnd,IDC_CHECK6),BM_SETCHECK,BST_CHECKED,0L);
	else SendMessage(GetDlgItem(data->hwnd,IDC_CHECK6),BM_SETCHECK,BST_UNCHECKED,0L);

	SetWindowText(GetDlgItem(data->hwnd,IDC_CHECK1),itemnames[data->startpage+data->pagenum][0]);
	SetWindowText(GetDlgItem(data->hwnd,IDC_CHECK2),itemnames[data->startpage+data->pagenum][1]);
	SetWindowText(GetDlgItem(data->hwnd,IDC_CHECK3),itemnames[data->startpage+data->pagenum][2]);
	SetWindowText(GetDlgItem(data->hwnd,IDC_CHECK4),itemnames[data->startpage+data->pagenum][3]);
	SetWindowText(GetDlgItem(data->hwnd,IDC_CHECK5),itemnames[data->startpage+data->pagenum][4]);
	SetWindowText(GetDlgItem(data->hwnd,IDC_CHECK6),itemnames[data->startpage+data->pagenum][5]);
}


BOOL CALLBACK LetterProc(HWND hwnd,UINT msg,UINT wparam,LONG lparam)
{
	static DATA letter;
	switch(msg)
	{
		case	WM_INITDIALOG:
					letter.hwnd = hwnd;
					letter.pagenum = 0;
					letter.pages = HIWORD(lparam);
					letter.id = idtable[LOWORD(lparam)];
					letter.chapter = LOWORD(lparam);
					letter.bmap = NULL;
					letter.startpage = startpage;
					LoadLetterData((DATA *)&letter);
					break;
		case	WM_DESTROY:
					DeleteObject(letter.bmap);
					EndDialog(hwnd,TRUE);
					return(TRUE);
		case	WM_CLOSE:
					SendMessage(hwnd,WM_DESTROY,0,0L);
					return(TRUE);
		case	WM_COMMAND:
					switch(LOWORD(wparam))
					{
						case	IDC_BACK:
									SendMessage(GetParent(hwnd),WM_APP,7,0L);
									break;
						case	IDC_NEXTPAGE:
									letter.pagenum++;
									LoadLetterData((DATA *)&letter);
									break;
						case	IDC_PREVPAGE:
									letter.pagenum--;
									LoadLetterData((DATA *)&letter);
									break;
						case	IDC_CHECK1:
									if(SendMessage(GetDlgItem(hwnd,IDC_CHECK1),BM_GETCHECK,0,0L) == BST_CHECKED)
									letteritem[letter.startpage+letter.pagenum].fit[0] = 1;
									else letteritem[letter.startpage+letter.pagenum].fit[0] = 0;
									break;
						case	IDC_CHECK2:
									if(SendMessage(GetDlgItem(hwnd,IDC_CHECK2),BM_GETCHECK,0,0L) == BST_CHECKED)
									letteritem[letter.startpage+letter.pagenum].fit[1] = 1;
									else letteritem[letter.startpage+letter.pagenum].fit[1] = 0;
									break;
						case	IDC_CHECK3:
									if(SendMessage(GetDlgItem(hwnd,IDC_CHECK3),BM_GETCHECK,0,0L) == BST_CHECKED)
									letteritem[letter.startpage+letter.pagenum].fit[2] = 1;
									else letteritem[letter.startpage+letter.pagenum].fit[2] = 0;
									break;
						case	IDC_CHECK4:
									if(SendMessage(GetDlgItem(hwnd,IDC_CHECK4),BM_GETCHECK,0,0L) == BST_CHECKED)
									letteritem[letter.startpage+letter.pagenum].fit[3] = 1;
									else letteritem[letter.startpage+letter.pagenum].fit[3] = 0;
									break;
						case	IDC_CHECK5:
									if(SendMessage(GetDlgItem(hwnd,IDC_CHECK5),BM_GETCHECK,0,0L) == BST_CHECKED)
									letteritem[letter.startpage+letter.pagenum].fit[4] = 1;
									else letteritem[letter.startpage+letter.pagenum].fit[4] = 0;
									break;
						case	IDC_CHECK6:
									if(SendMessage(GetDlgItem(hwnd,IDC_CHECK6),BM_GETCHECK,0,0L) == BST_CHECKED)
									letteritem[letter.startpage+letter.pagenum].fit[5] = 1;
									else letteritem[letter.startpage+letter.pagenum].fit[5] = 0;
									break;
						default:
									break;
					}
					break;
	}
	return(FALSE);
}


char firstname[32],lastname[32],born[12];
void Generate(HWND hwnd);
BOOL CALLBACK AdviceProc(HWND hwnd,UINT msg,UINT wparam,LONG lparam)
{
	switch(msg)
	{
		case	WM_INITDIALOG:
					SendMessage(GetDlgItem(hwnd,IDC_FIRSTNAME),EM_LIMITTEXT,31,0L);
					SendMessage(GetDlgItem(hwnd,IDC_LASTNAME),EM_LIMITTEXT,31,0L);
					SendMessage(GetDlgItem(hwnd,IDC_BORN),EM_LIMITTEXT,11,0L);
					EnableWindow(GetDlgItem(hwnd,IDC_PRINT),FALSE);
					EnableWindow(GetDlgItem(hwnd,IDC_SAVE),FALSE);
					EnableWindow(GetDlgItem(hwnd,IDC_CREATE),FALSE);
					ZeroMemory(&firstname,sizeof(firstname));
					ZeroMemory(&lastname,sizeof(lastname));
					ZeroMemory(&born,sizeof(born));
					return(TRUE);
		case	WM_DESTROY:
					EndDialog(hwnd,TRUE);
					return(TRUE);
		case	WM_CLOSE:
					SendMessage(hwnd,WM_DESTROY,0,0L);
					return(TRUE);
		case	WM_COMMAND:
					switch(LOWORD(wparam))
					{
						case	IDC_BACK:
									SendMessage(GetParent(hwnd),WM_APP,9,0L);
									break;
						case	IDC_SAVE:
									SaveAnalysis(hwnd);
									break;
						case	IDC_PRINT:
									if(PrintAnalysis(hwnd) == TRUE) 
									{
										analysen++;
										SaveCounter();
										LoadCounter();
										Status_Analysis();
									}
									break;
						case	IDC_CREATE:
									Generate(hwnd);
									EnableWindow(GetDlgItem(hwnd,IDC_PRINT),TRUE);
									EnableWindow(GetDlgItem(hwnd,IDC_SAVE),TRUE);
									break;
						case	IDC_FIRSTNAME:
						case	IDC_LASTNAME:
						case	IDC_BORN:
									if(HIWORD(wparam) == EN_CHANGE)
									{
										if(GetWindowText(GetDlgItem(hwnd,IDC_FIRSTNAME),firstname,sizeof(firstname)) == 0)
										{
											EnableWindow(GetDlgItem(hwnd,IDC_PRINT),FALSE);
											EnableWindow(GetDlgItem(hwnd,IDC_SAVE),FALSE);
											EnableWindow(GetDlgItem(hwnd,IDC_CREATE),FALSE);
										}
										else if(GetWindowText(GetDlgItem(hwnd,IDC_LASTNAME),lastname,sizeof(lastname)) == 0)
										{
											EnableWindow(GetDlgItem(hwnd,IDC_PRINT),FALSE);
											EnableWindow(GetDlgItem(hwnd,IDC_SAVE),FALSE);
											EnableWindow(GetDlgItem(hwnd,IDC_CREATE),FALSE);
										}
										else if(GetWindowText(GetDlgItem(hwnd,IDC_BORN),born,sizeof(born)) == 0)
										{
											EnableWindow(GetDlgItem(hwnd,IDC_PRINT),FALSE);
											EnableWindow(GetDlgItem(hwnd,IDC_SAVE),FALSE);
											EnableWindow(GetDlgItem(hwnd,IDC_CREATE),FALSE);
										}
										else
										{
//											EnableWindow(GetDlgItem(hwnd,IDC_PRINT),TRUE);
//											EnableWindow(GetDlgItem(hwnd,IDC_SAVE),TRUE);
											EnableWindow(GetDlgItem(hwnd,IDC_CREATE),TRUE);
										}
									}
									break;
						default:
									break;
					}
					break;
	}
	return(FALSE);
}


void Generate(HWND hwnd)
{
	int i,j,k,found;
	HWND rtf;
	char buf[MAX_PATH];

	rtf = GetDlgItem(hwnd,IDC_RICHEDIT);

	LoadRtfFromFile(rtf,".\\atxt\\intro.rtf");
	AppendTextFromMem(rtf,(char *)&lastname);
	AppendTextFromMem(rtf,", ");
	AppendTextFromMem(rtf,(char *)&firstname);
	AppendTextFromMem(rtf,", born ");
	AppendTextFromMem(rtf,(char *)&born);
	AppendTextFromMem(rtf,"\r\n\r\n\r\n");
	for(i=0; i<10; i++)
	{
//		sprintf(buf,".\\atxt\\%02d_header.rtf",i);
//		AppendRtfFromFile(rtf,buf);
		found = 0;

		if(i == 6)
		{
			for(j=0; j<22; j++)
			{
				for(k=0; k<10; k++)
				{
					if(letteritem[j].fit[k])
					{
						if(found == 0)
						{
							sprintf(buf,".\\atxt\\%02d_header.rtf",i);
							AppendRtfFromFile(rtf,buf);
						}
						sprintf(buf,".\\atxt\\%02d%02d%02d.rtf",i,j,k);
						AppendRtfFromFile(rtf,buf);
						AppendTextFromMem(rtf,"\r\n");
						found = 1;
					}
				}
			}
		}
		else
		{
			for(j=0; j<11; j++)
			{
				if(item[i].fit[j])
				{
					if(found == 0)
					{
						sprintf(buf,".\\atxt\\%02d_header.rtf",i);
						AppendRtfFromFile(rtf,buf);
					}
					sprintf(buf,".\\atxt\\%02d%02d.rtf",i,j);
					AppendRtfFromFile(rtf,buf);
					AppendTextFromMem(rtf,"\r\n");
					found = 1;
				}
			}
		}
//		if(!found) AppendTextFromMem(rtf,"No selection made!\r\n\r\n\r\n");
	}
}



BOOL SaveAnalysis(HWND hwnd)
{
	char szFile[MAX_PATH],szFileTitle[MAX_PATH];
	char szFilter[] = "RTF File (*.rtf)\0*.rtf\0\0";
	OPENFILENAME ofn;

	memset(&ofn,0,sizeof(OPENFILENAME));
	szFile[0] = szFileTitle[0] = 0;
	ofn.lStructSize				= sizeof(OPENFILENAME);
	ofn.hwndOwner					= hwnd;
	ofn.hInstance					= myinstance;
	ofn.lpstrFilter				= (LPSTR)szFilter;
	ofn.nMaxFile					= sizeof(szFile);
	ofn.nMaxFileTitle			= sizeof(szFileTitle);
	ofn.lpstrFile					= szFile;
	ofn.lpstrFileTitle		= szFileTitle;
	ofn.lpstrInitialDir		= ".\\";
	ofn.lpstrDefExt				= "*.*";
	ofn.lpstrTitle				= "Choose or enter the filename";
	ofn.Flags             = OFN_NOCHANGEDIR | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_EXPLORER | OFN_OVERWRITEPROMPT;
	if(GetSaveFileName(&ofn) == FALSE) return(FALSE);
	WriteRtfToFile(GetDlgItem(hwnd,IDC_RICHEDIT),szFile);
	MessageBox(hwnd,"Graphology advice saved.","Message",MB_OK|MB_ICONINFORMATION);
	return(TRUE);
}



/*****************
 * PRINTER STUFF *
 *****************/
void FillRichEdit(HWND hwnd,HWND hwndprinter)
{
	DeleteFile(".\\~tmp.rtf");
	WriteRtfToFile(GetDlgItem(hwnd,IDC_RICHEDIT),".\\~tmp.rtf");
	LoadRtfFromFile(hwndprinter,".\\~tmp.rtf");
}


BOOL abortprinting;
HWND hDlgPrint;
BOOL CALLBACK ReqProc(HWND hwnd,UINT msg,UINT wparam,LONG lparam)
{
	switch(msg)
	{
		case	WM_INITDIALOG:
					hDlgPrint = hwnd;
					abortprinting = FALSE;
					return(TRUE);
		case	WM_DESTROY:
					EndDialog(hwnd,TRUE);
					return(TRUE);
		case	WM_CLOSE:
					SendMessage(hwnd,WM_DESTROY,0,0L);
					return(TRUE);
		case	WM_COMMAND:
					switch(LOWORD(wparam))
					{
						case	IDCANCEL:
									abortprinting = TRUE;
									DestroyWindow(hwnd);
									break;
					}
	}
	return(FALSE);
}


BOOL CALLBACK AbortProc(HDC hdc,int error)
{
	MSG msg;
	while(!abortprinting && PeekMessage(&msg,NULL,0,0,PM_REMOVE))
	{ 
		if(!hDlgPrint || !IsDialogMessage(hDlgPrint,&msg))
		{ 
			TranslateMessage(&msg); 
			DispatchMessage (&msg); 
		} 
	} 
	return !abortprinting; 
}


typedef struct
{
	float xPerInch;			// Pixel per Inch
	float yPerInch;			// Pixel per Inch
	float xPerMM;				// Pixel per MM
	float yPerMM;				// Pixel per MM
	float xPixelPage;		// Page width in Pixel
	float yPixelPage;		// Page height in Pixel
	float	xInchPage;		// Page width in Inch
	float yInchPage;		// Page height in Inch
	float xMMPage;			// Page width in MM
	float yMMPage;			// Page height in MM
	float xPixelOffset;	// Left offset in Pixel
	float yPixelOffset;	// Top offset in Pixel
	float xInchOffset;	// Left offset in Inch
	float yInchOffset;	// Top offset in Inch
	float xMMOffset;		// Left offset in MM
	float yMMOffset;		// Top offset in MM
	int printercolors;
	int caps;
	RECT mm_area;				// Printable area in MM
	RECT twips_area;		// Printable area in TWIPS
	RECT pixel_area;		// Printable area in Pixel
	RECT mm_margins;		// User defines of margins in mm
	PRINTDLG pd;				// Printer Dialog Structure
	DOCINFO di;					// DOCINFO
	int rtf;						// 0 = NO RTF, 1 = RTF
} PAGE;

#define	TWIPS_PER_INCH	(float)1440.0f
#define	TWIPS_PER_MM	((float)TWIPS_PER_INCH / 25.4f)
#define	IN_MMX(x) (x*page.xPerMM)
#define	IN_MMY(x) (x*page.yPerMM)

BOOL ChoosePrinter(HWND hwnd,PAGE *page,char *txt)
{
	ZeroMemory(&page->pd,sizeof(PRINTDLG));
	page->pd.lStructSize = sizeof(PRINTDLG);
	page->pd.hwndOwner = hwnd;
	page->pd.hInstance = myinstance;
	page->pd.nFromPage = 0;
	page->pd.nToPage = 0;
	page->pd.nMinPage = 0;
	page->pd.nMaxPage = 0;
	page->pd.nCopies = 1;
	page->pd.Flags = PD_NOPAGENUMS|PD_NOSELECTION|PD_USEDEVMODECOPIES|PD_COLLATE|PD_RETURNDC|PD_HIDEPRINTTOFILE|PD_NONETWORKBUTTON;
	if(!PrintDlg(&page->pd)) return(FALSE);

	ZeroMemory(&page->di,sizeof(DOCINFO));
	page->di.cbSize = sizeof(DOCINFO);
	page->di.lpszDocName = txt;
	page->di.lpszOutput = NULL;

	return(TRUE);
}


int PrintInit(HWND hwnd,PAGE *page)
{
	page->printercolors = GetDeviceCaps(page->pd.hDC,NUMCOLORS);
	page->caps = GetDeviceCaps(page->pd.hDC,RASTERCAPS);

	page->xPerInch = (float)GetDeviceCaps(page->pd.hDC,LOGPIXELSX);					// X Pixel Per Inch
	page->yPerInch = (float)GetDeviceCaps(page->pd.hDC,LOGPIXELSY);					// Y Pixel Per Inch
	page->xPerMM = page->xPerInch / 25.4f;																	// X Pixel Per MM
	page->yPerMM = page->yPerInch / 25.4f;																	// Y Pixel Per MM
	page->xPixelPage = (float)GetDeviceCaps(page->pd.hDC,PHYSICALWIDTH);		// Pagewidth in Pixel
	page->yPixelPage = (float)GetDeviceCaps(page->pd.hDC,PHYSICALHEIGHT);		// Pageheight in Pixel
	page->xInchPage = page->xPixelPage / page->xPerInch;
	page->yInchPage = page->yPixelPage / page->yPerInch;
	page->xMMPage = page->xPixelPage / page->xPerInch * 25.4f;
	page->yMMPage = page->yPixelPage / page->yPerInch * 25.4f;
	page->xPixelOffset = (float)GetDeviceCaps(page->pd.hDC,PHYSICALOFFSETX);// Pixel left offset
	page->yPixelOffset = (float)GetDeviceCaps(page->pd.hDC,PHYSICALOFFSETY);// Pixel right offset
	page->xInchOffset = page->xPixelOffset / page->xPerInch;
	page->yInchOffset = page->yPixelOffset / page->yPerInch;
	page->xMMOffset = page->xPixelOffset / page->xPerInch * 25.4f;
	page->yMMOffset = page->yPixelOffset / page->yPerInch * 25.4f;

// Define margins (MM)
	page->mm_margins.left = (long)(20.0f - page->xMMOffset);
	page->mm_margins.top = (long)(20.0f - page->yMMOffset);
	page->mm_margins.right = 20;
	page->mm_margins.bottom = 15;

// Calculate printable area in MM
	page->mm_area.left = page->mm_margins.left;
	page->mm_area.top = page->mm_margins.top;
	page->mm_area.right = (long)(page->xMMPage - page->mm_margins.right);
	page->mm_area.bottom = (long)(page->yMMPage - page->mm_margins.bottom);

// Calculate printable area in TWIPS
	page->twips_area.left = (long)(TWIPS_PER_MM * page->mm_area.left);			// left position in TWIPS
	page->twips_area.top = (long)(TWIPS_PER_MM * page->mm_area.top);				// top position in TWIPS
	page->twips_area.right = (long)(TWIPS_PER_MM * page->mm_area.right);
	page->twips_area.bottom = (long)(TWIPS_PER_MM * page->mm_area.bottom);

// Calculate the printable area in pixel
	page->pixel_area.left = (long)(page->mm_area.left * page->xPerMM);
	page->pixel_area.top = (long)(page->mm_area.top * page->yPerMM);
	page->pixel_area.right = (long)(page->mm_area.right * page->xPerMM);
	page->pixel_area.bottom = (long)(page->mm_area.bottom * page->yPerMM);


	return(1);
}


BOOL PrintAnalysis(HWND hwnd)
{
	char *errcodetext[] = {"Start of Doc","Start of Page","End of Page","End of Doc"};
	int errcode; 
	RECT rc;
	HWND hwnd_printer;
	HWND hwnd_requester;
	char buf[160];

	PAGE page;

	if(ChoosePrinter(hwnd,&page,"Graphology Advisor Printout") == FALSE) return(FALSE);

	PrintInit(hwnd,&page);

	page.rtf = 1;
	hwnd_requester = CreateDialog(myinstance,"PrintDlg",hwnd,ReqProc);
	ShowWindow(hwnd_requester,SW_SHOW);
	UpdateWindow(hwnd_requester);
	hwnd_printer = GetDlgItem(hwnd_requester,IDC_RICHEDIT);


	FillRichEdit(hwnd,hwnd_printer);

	SetAbortProc(page.pd.hDC,AbortProc);

	rc = page.pixel_area;

	FORMATRANGE fr;
	long textlen;
	int printpic;

	printpic = 0;
	textlen = SendMessage(hwnd_printer,WM_GETTEXTLENGTH, 0, 0);
	fr.hdc = page.pd.hDC;
	fr.hdcTarget = 0;
	fr.rc = page.twips_area;
	fr.rcPage = page.twips_area;
	fr.chrg.cpMin = 0;
	fr.chrg.cpMax = textlen;

	if(StartDoc(page.pd.hDC,&page.di) <= 0) {errcode = 1; goto err;}

	do
	{
		if(StartPage(page.pd.hDC) <= 0) {errcode = 2; goto abort;}
		fr.rc = page.twips_area;
		fr.rcPage = page.twips_area;
		fr.chrg.cpMin = SendMessage(hwnd_printer,EM_FORMATRANGE,(WPARAM)TRUE,(LPARAM)&fr);
		if(EndPage(page.pd.hDC) <= 0) goto abort;
	} while(fr.chrg.cpMin > 0 && fr.chrg.cpMin < fr.chrg.cpMax);

	fr.chrg.cpMin = fr.chrg.cpMax = textlen;
	SendMessage(hwnd_printer,EM_FORMATRANGE,0,0);

	if(EndDoc(page.pd.hDC) <= 0) {errcode = 4; goto abort;}
	DeleteDC(page.pd.hDC);
	DestroyWindow(hwnd_requester);
	return(TRUE);

abort:
	AbortDoc(page.pd.hDC);
err:
	DeleteDC(page.pd.hDC);
	fr.chrg.cpMin = fr.chrg.cpMax = textlen;
	SendMessage(hwnd_printer,EM_FORMATRANGE, 0, 0);
	DestroyWindow(hwnd_requester);
	if(abortprinting == FALSE) sprintf(buf,"An error occured while printing!\r\nErrorCode: %d = %s",errcode,errcodetext[errcode-1]); 
	else strcpy(buf,"Printing aborted by user request!");
	MessageBox(hwnd,buf,"Print job aborted",MB_ICONSTOP|MB_OK);
	return(FALSE);
}
#undef IN_MMX
#undef IN_MMY
#undef TWIPS_PER_INCH
#undef TWIPS_PER_MM
