#include <windows.h>
#include <winuser.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <time.h>
#include <commctrl.h>
#include <richedit.h>
#include "myrtf.h"


DWORD InitMyRtf()
{
	HINSTANCE lib;
	if(lib = LoadLibrary("RichEd32.dll")) return(1);
	return(0);
}


DWORD CALLBACK RtfMyReadFromFile(DWORD dwCookie, LPBYTE pbBuffer, LONG cb, LONG *pcb)
{
	HFILE	hf = (HFILE) dwCookie;
	if(hf == HFILE_ERROR)	return (DWORD)E_FAIL;
	*pcb = _lread(hf, pbBuffer, cb);
	return (DWORD) (*pcb >= 0 ? NOERROR : (*pcb = 0, E_FAIL));
}


DWORD CALLBACK RtfMyWriteToFile(DWORD dwCookie, LPBYTE pbBuffer, LONG cb, LONG *pcb)
{
	HFILE	hf = (HFILE) dwCookie;
	*pcb = _lwrite(hf,(LPCSTR)pbBuffer,cb);
	return (DWORD) (*pcb >= 0 ? NOERROR : (*pcb = 0, E_FAIL));
}


DWORD CALLBACK RtfMyReadFromMem(DWORD dwCookie, LPBYTE pbBuffer, LONG cb, LONG *pcb)
{
	STREAMFILE *ptr = (STREAMFILE *)dwCookie;
	if(ptr->offset == ptr->maxlen)
	{
		*pcb = 0;
	}
	else
	{
		if(ptr->offset + cb > ptr->maxlen)
		{
			*pcb = ptr->maxlen-ptr->offset;
			memcpy(pbBuffer,&ptr->pointer[ptr->offset],*pcb);
			ptr->offset = ptr->maxlen;
		}
		else
		{
			*pcb = cb;
			memcpy(pbBuffer,&ptr->pointer[ptr->offset],*pcb);
			ptr->offset += cb;
		}
	}
	return (DWORD) (*pcb >= 0 ? NOERROR : (*pcb = 0, E_FAIL));
}


DWORD LoadRtfFromFile(HWND hwnd,char *name)
{
	LONG cch;
	EDITSTREAM es;
	DWORD dwFormat;

	dwFormat = SF_RTF;
	es.dwCookie = (DWORD)_lopen(name,OF_READ);
	if(es.dwCookie == HFILE_ERROR) return(0);
	es.dwError = 0;
	es.pfnCallback = RtfMyReadFromFile;
//	SendMessage(hwnd,WM_SETREDRAW,(WPARAM)FALSE,0);
	cch = SendMessage(hwnd,EM_STREAMIN,(WPARAM)dwFormat,(LPARAM)&es);
	_lclose((HFILE) es.dwCookie);
	UpdateWindow(hwnd);
//	SendMessage(hwnd,WM_SETREDRAW,(WPARAM)TRUE,0);
	return(1);
}


DWORD AppendRtfFromFile(HWND hwnd,char *name)
{
	LONG cch;
	EDITSTREAM es;
	DWORD dwFormat;
	CHARRANGE cr;
	cr.cpMin = -1;
	cr.cpMax = -1;
	dwFormat = SF_RTF;
	es.dwCookie = (DWORD)_lopen(name,OF_READ);
	if(es.dwCookie == HFILE_ERROR) return(0);
	es.dwError = 0;
	es.pfnCallback = RtfMyReadFromFile;
	SendMessage(hwnd,WM_SETREDRAW,(WPARAM)FALSE,0);
	SendMessage(hwnd,EM_EXSETSEL,0,(LPARAM)&cr);
	cch = SendMessage(hwnd,EM_STREAMIN,(WPARAM)dwFormat|SFF_SELECTION,(LPARAM)&es);
	_lclose((HFILE) es.dwCookie);
	UpdateWindow(hwnd);
	SendMessage(hwnd,WM_SETREDRAW,(WPARAM)TRUE,0);
	return(1);
}


DWORD WriteRtfToFile(HWND hwnd,char *name)
{
	EDITSTREAM es;
	DWORD dwFormat;
	LONG cch;

	dwFormat = SF_RTF;
	es.dwCookie = (DWORD)_lcreat(name,0);
	if(es.dwCookie == HFILE_ERROR) return(0);
	es.dwError = 0;
	es.pfnCallback = RtfMyWriteToFile;
	cch = SendMessage(hwnd,EM_STREAMOUT,(WPARAM)dwFormat,(LPARAM)&es);
	_lclose((HFILE) es.dwCookie);
	return(1);
}


DWORD LoadTextFromFile(HWND hwnd,char *name)
{
	LONG cch;
	EDITSTREAM es;
	DWORD dwFormat;

	dwFormat = SF_TEXT;
	es.dwCookie = (DWORD)_lopen(name,OF_READ);
	if(es.dwCookie == HFILE_ERROR) return(0);
	es.dwError = 0;
	es.pfnCallback = RtfMyReadFromFile;
	SendMessage(hwnd,WM_SETREDRAW,(WPARAM)FALSE,0);
	cch = SendMessage(hwnd,EM_STREAMIN,(WPARAM)dwFormat,(LPARAM)&es);
	_lclose((HFILE) es.dwCookie);
	SendMessage(hwnd,EM_SETMODIFY,(WPARAM)FALSE,0);
	SendMessage(hwnd,WM_SETREDRAW,(WPARAM)TRUE,0);
	UpdateWindow(hwnd);
	return(1);
}


DWORD AppendTextFromFile(HWND hwnd,char *name)
{
	LONG cch;
	EDITSTREAM es;
	DWORD dwFormat;
	CHARRANGE cr;
	cr.cpMin = -1;
	cr.cpMax = -1;
	dwFormat = SF_TEXT;
	es.dwCookie = (DWORD)_lopen(name,OF_READ);
	if(es.dwCookie == HFILE_ERROR) return(0);
	es.dwError = 0;
	es.pfnCallback = RtfMyReadFromFile;
	SendMessage(hwnd,WM_SETREDRAW,(WPARAM)FALSE,0);
	SendMessage(hwnd,EM_EXSETSEL,0,(LPARAM)&cr);
	cch = SendMessage(hwnd,EM_STREAMIN,(WPARAM)dwFormat|SFF_SELECTION,(LPARAM)&es);
	_lclose((HFILE) es.dwCookie);
	UpdateWindow(hwnd);
	SendMessage(hwnd,WM_SETREDRAW,(WPARAM)TRUE,0);
	return(1);
}



DWORD WriteTextToFile(HWND hwnd,char *name)
{
	EDITSTREAM es;
	DWORD dwFormat;
	LONG cch;

	dwFormat = SF_TEXT;
	es.dwCookie = (DWORD)_lcreat(name,0);
	if(es.dwCookie == HFILE_ERROR) return(0);
	es.dwError = 0;
	es.pfnCallback = RtfMyWriteToFile;
	cch = SendMessage(hwnd,EM_STREAMOUT,(WPARAM)dwFormat,(LPARAM)&es);
	_lclose((HFILE) es.dwCookie);
	return(1);
}



DWORD LoadRtfFromMem(HWND hwnd,char *txt)
{
	LONG cch;
	EDITSTREAM es;
	DWORD dwFormat;
	STREAMFILE sf;

	sf.offset = 0;
	sf.maxlen = strlen(txt);
	sf.pointer = txt;
	dwFormat = SF_RTF;
	es.dwCookie = (DWORD)&sf;
	es.dwError = 0;
	es.pfnCallback = RtfMyReadFromMem;
	SendMessage(hwnd,WM_SETREDRAW,(WPARAM)FALSE,0);
	cch = SendMessage(hwnd,EM_STREAMIN,(WPARAM)dwFormat,(LPARAM)&es);
	UpdateWindow(hwnd);
	SendMessage(hwnd,WM_SETREDRAW,(WPARAM)TRUE,0);
	return(1);
}


DWORD AppendRtfFromMem(HWND hwnd,char *txt)
{
	LONG cch;
	EDITSTREAM es;
	DWORD dwFormat;
	CHARRANGE cr;
	STREAMFILE sf;

	sf.offset = 0;
	sf.maxlen = strlen(txt);
	sf.pointer = txt;

	cr.cpMin = -1;
	cr.cpMax = -1;
	dwFormat = SF_RTF;
	es.dwCookie = (DWORD)&sf;
	es.dwError = 0;
	es.pfnCallback = RtfMyReadFromMem;
	SendMessage(hwnd,WM_SETREDRAW,(WPARAM)FALSE,0);
	SendMessage(hwnd,EM_EXSETSEL,0,(LPARAM)&cr);
	cch = SendMessage(hwnd,EM_STREAMIN,(WPARAM)dwFormat,(LPARAM)&es);
	UpdateWindow(hwnd);
	SendMessage(hwnd,WM_SETREDRAW,(WPARAM)TRUE,0);
	return(1);
}



DWORD LoadRtfFromRes(HWND hwnd,char *resname)
{
	LONG cch;
	EDITSTREAM es;
	DWORD dwFormat;
	STREAMFILE sf;
	HRSRC res;

	res = FindResource(NULL,resname,"MYRES");
	if(res != NULL)
	{
		sf.offset = 0;
		sf.maxlen = SizeofResource(NULL,res);
		sf.pointer = (char *)LockResource(LoadResource(NULL,res));
		dwFormat = SF_RTF;
		es.dwCookie = (DWORD)&sf;
		es.dwError = 0;
		es.pfnCallback = RtfMyReadFromMem;
		SendMessage(hwnd,WM_SETREDRAW,(WPARAM)FALSE,0);
		cch = SendMessage(hwnd,EM_STREAMIN,(WPARAM)dwFormat,(LPARAM)&es);
		UpdateWindow(hwnd);
		SendMessage(hwnd,WM_SETREDRAW,(WPARAM)TRUE,0);
		return(1);
	}
	return(0);
}


DWORD AppendRtfFromRes(HWND hwnd,char *resname)
{
	LONG cch;
	EDITSTREAM es;
	DWORD dwFormat;
	CHARRANGE cr;
	STREAMFILE sf;
	HRSRC res;

	res = FindResource(NULL,resname,"MYRES");
	if(res != NULL)
	{
		cr.cpMin = -1;
		cr.cpMax = -1;
		sf.offset = 0;
		sf.maxlen = SizeofResource(NULL,res);
		sf.pointer = (char *)LockResource(LoadResource(NULL,res));
		dwFormat = SF_RTF;
		es.dwCookie = (DWORD)&sf;
		es.dwError = 0;
		es.pfnCallback = RtfMyReadFromMem;
		SendMessage(hwnd,WM_SETREDRAW,(WPARAM)FALSE,0);
		SendMessage(hwnd,EM_EXSETSEL,0,(LPARAM)&cr);
		cch = SendMessage(hwnd,EM_STREAMIN,(WPARAM)dwFormat,(LPARAM)&es);
		UpdateWindow(hwnd);
		SendMessage(hwnd,WM_SETREDRAW,(WPARAM)TRUE,0);
		return(1);
	}
	return(0);
}


DWORD LoadTextFromMem(HWND hwnd,char *txt)
{
	LONG cch;
	EDITSTREAM es;
	DWORD dwFormat;
	STREAMFILE sf;

	sf.offset = 0;
	sf.maxlen = strlen(txt);
	sf.pointer = txt;
	dwFormat = SF_TEXT;
	es.dwCookie = (DWORD)&sf;
	es.dwError = 0;
	es.pfnCallback = RtfMyReadFromMem;
	SendMessage(hwnd,WM_SETREDRAW,(WPARAM)FALSE,0);
	cch = SendMessage(hwnd,EM_STREAMIN,(WPARAM)dwFormat,(LPARAM)&es);
	UpdateWindow(hwnd);
	SendMessage(hwnd,WM_SETREDRAW,(WPARAM)TRUE,0);
	return(1);
}


DWORD AppendTextFromMem(HWND hwnd,char *txt)
{
	LONG cch;
	EDITSTREAM es;
	DWORD dwFormat;
	CHARRANGE cr;
	STREAMFILE sf;

	sf.offset = 0;
	sf.maxlen = strlen(txt);
	sf.pointer = txt;

	cr.cpMin = -1;
	cr.cpMax = -1;
	dwFormat = SF_TEXT;
	es.dwCookie = (DWORD)&sf;
	es.dwError = 0;
	es.pfnCallback = RtfMyReadFromMem;
	SendMessage(hwnd,WM_SETREDRAW,(WPARAM)FALSE,0);
	SendMessage(hwnd,EM_EXSETSEL,0,(LPARAM)&cr);
	cch = SendMessage(hwnd,EM_STREAMIN,(WPARAM)dwFormat,(LPARAM)&es);
	UpdateWindow(hwnd);
	SendMessage(hwnd,WM_SETREDRAW,(WPARAM)TRUE,0);
	return(1);
}



DWORD LoadTextFromRes(HWND hwnd,char *resname)
{
	LONG cch;
	EDITSTREAM es;
	DWORD dwFormat;
	STREAMFILE sf;
	HRSRC res;

	res = FindResource(NULL,resname,"MYRES");
	if(res != NULL)
	{
		sf.offset = 0;
		sf.maxlen = SizeofResource(NULL,res);
		sf.pointer = (char *)LockResource(LoadResource(NULL,res));
		dwFormat = SF_TEXT;
		es.dwCookie = (DWORD)&sf;
		es.dwError = 0;
		es.pfnCallback = RtfMyReadFromMem;
		SendMessage(hwnd,WM_SETREDRAW,(WPARAM)FALSE,0);
		cch = SendMessage(hwnd,EM_STREAMIN,(WPARAM)dwFormat,(LPARAM)&es);
		UpdateWindow(hwnd);
		SendMessage(hwnd,WM_SETREDRAW,(WPARAM)TRUE,0);
		return(1);
	}
	return(0);
}


DWORD AppendTextFromRes(HWND hwnd,char *resname)
{
	LONG cch;
	EDITSTREAM es;
	DWORD dwFormat;
	CHARRANGE cr;
	STREAMFILE sf;
	HRSRC res;

	res = FindResource(NULL,resname,"MYRES");
	if(res != NULL)
	{
		cr.cpMin = -1;
		cr.cpMax = -1;
		sf.offset = 0;
		sf.maxlen = SizeofResource(NULL,res);
		sf.pointer = (char *)LockResource(LoadResource(NULL,res));
		dwFormat = SF_TEXT;
		es.dwCookie = (DWORD)&sf;
		es.dwError = 0;
		es.pfnCallback = RtfMyReadFromMem;
		SendMessage(hwnd,WM_SETREDRAW,(WPARAM)FALSE,0);
		SendMessage(hwnd,EM_EXSETSEL,0,(LPARAM)&cr);
		cch = SendMessage(hwnd,EM_STREAMIN,(WPARAM)dwFormat,(LPARAM)&es);
		UpdateWindow(hwnd);
		SendMessage(hwnd,WM_SETREDRAW,(WPARAM)TRUE,0);
		return(1);
	}
	return(0);
}
